summaryrefslogtreecommitdiffstats
path: root/source/installer/sources
diff options
context:
space:
mode:
Diffstat (limited to 'source/installer/sources')
-rwxr-xr-xsource/installer/sources/bricktick/fetch-bricktick.sh52
-rw-r--r--source/installer/sources/dnsmasq/dnsmasq-2.80-SIOCGSTAMP.patch60
-rw-r--r--source/installer/sources/dnsmasq/dnsmasq.leasedir.diff24
-rw-r--r--source/installer/sources/dnsmasq/dnsmasq.libidn2.diff13
-rw-r--r--source/installer/sources/initrd/etc/keymaps.tarbin573440 -> 0 bytes
l---------source/installer/sources/initrd/etc/mtab (renamed from source/installer/sources/initrd/etc/mounts)0
-rwxr-xr-xsource/installer/sources/initrd/etc/rc.d/rc.S51
-rwxr-xr-xsource/installer/sources/initrd/etc/rc.d/rc.pcmcia2
-rwxr-xr-xsource/installer/sources/initrd/sbin/mkbindmounts10
-rwxr-xr-xsource/installer/sources/initrd/sbin/probe73
-rwxr-xr-xsource/installer/sources/initrd/usr/lib/setup/INS-all-in-one199
-rwxr-xr-xsource/installer/sources/initrd/usr/lib/setup/SeTEFI17
-rwxr-xr-xsource/installer/sources/initrd/usr/lib/setup/SeTconfig4
-rwxr-xr-xsource/installer/sources/initrd/usr/lib/setup/SeTkeymap183
-rwxr-xr-xsource/installer/sources/initrd/usr/lib/setup/SeTmedia12
-rwxr-xr-xsource/installer/sources/initrd/usr/lib/setup/SeTpasswd2
-rwxr-xr-xsource/installer/sources/initrd/usr/lib/setup/pxesetup4
-rwxr-xr-xsource/installer/sources/initrd/usr/lib/setup/setup56
18 files changed, 540 insertions, 222 deletions
diff --git a/source/installer/sources/bricktick/fetch-bricktick.sh b/source/installer/sources/bricktick/fetch-bricktick.sh
new file mode 100755
index 000000000..15a8e2b14
--- /dev/null
+++ b/source/installer/sources/bricktick/fetch-bricktick.sh
@@ -0,0 +1,52 @@
+#!/bin/sh
+
+# Copyright 2019, 2020 Patrick J. Volkerding, Sebeka, Minnesota, USA
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+
+PKGNAM=bricktick
+
+# Pull a stable branch + patches
+BRANCH=${1:-master}
+
+# Clear download area:
+rm -rf ${PKGNAM}
+
+# Clone repository:
+git clone https://github.com/Subsentient/${PKGNAM}
+
+# checkout $BRANCH:
+( cd ${PKGNAM}
+ git checkout $BRANCH || exit 1
+)
+
+HEADISAT="$( cd ${PKGNAM} && git log -1 --format=%h )"
+DATE="$( cd ${PKGNAM} && git log -1 --format=%cd --date=format:%Y%m%d )"
+LONGDATE="$( cd ${PKGNAM} && git log -1 --format=%cd --date=format:%c )"
+# Cleanup. We're not packing up the whole git repo.
+( cd ${PKGNAM} && find . -type d -name ".git*" -exec rm -rf {} \; 2> /dev/null )
+mv ${PKGNAM} ${PKGNAM}-${DATE}_${HEADISAT}
+tar cf ${PKGNAM}-${DATE}_${HEADISAT}.tar ${PKGNAM}-${DATE}_${HEADISAT}
+plzip -9 -f ${PKGNAM}-${DATE}_${HEADISAT}.tar
+rm -rf ${PKGNAM}-${DATE}_${HEADISAT}
+touch -d "$LONGDATE" ${PKGNAM}-${DATE}_${HEADISAT}.tar.lz
+echo
+echo "${PKGNAM} branch $BRANCH with HEAD at $HEADISAT packaged as ${PKGNAM}-${DATE}_${HEADISAT}.tar.lz"
+echo
diff --git a/source/installer/sources/dnsmasq/dnsmasq-2.80-SIOCGSTAMP.patch b/source/installer/sources/dnsmasq/dnsmasq-2.80-SIOCGSTAMP.patch
new file mode 100644
index 000000000..3a32bb82e
--- /dev/null
+++ b/source/installer/sources/dnsmasq/dnsmasq-2.80-SIOCGSTAMP.patch
@@ -0,0 +1,60 @@
+From 31e14f6e52677c675ee4683f9daab5bf21c07dd6 Mon Sep 17 00:00:00 2001
+From: Petr Mensik <pemensik@redhat.com>
+Date: Wed, 31 Jul 2019 20:35:35 +0200
+Subject: [PATCH] Recent kernel no longer supports SIOCGSTAMP
+
+Build without it defined by kernel headers. Do not try SO_TIMESTAMP
+until fixed properly.
+---
+ src/dhcp.c | 32 ++++++++++++++++++--------------
+ 1 file changed, 18 insertions(+), 14 deletions(-)
+
+diff --git a/src/dhcp.c b/src/dhcp.c
+index f8d323b..9afdccf 100644
+--- a/src/dhcp.c
++++ b/src/dhcp.c
+@@ -178,23 +178,27 @@ void dhcp_packet(time_t now, int pxe_fd)
+ (sz < (ssize_t)(sizeof(*mess) - sizeof(mess->options))))
+ return;
+
+- #if defined (HAVE_LINUX_NETWORK)
+- if (ioctl(fd, SIOCGSTAMP, &tv) == 0)
++#if defined (HAVE_LINUX_NETWORK)
++#ifdef SIOCGSTAMP
++ if (tv.tv_sec == 0 && ioctl(fd, SIOCGSTAMP, &tv) == 0)
+ recvtime = tv.tv_sec;
++#endif
+
+ if (msg.msg_controllen >= sizeof(struct cmsghdr))
+- for (cmptr = CMSG_FIRSTHDR(&msg); cmptr; cmptr = CMSG_NXTHDR(&msg, cmptr))
+- if (cmptr->cmsg_level == IPPROTO_IP && cmptr->cmsg_type == IP_PKTINFO)
+- {
+- union {
+- unsigned char *c;
+- struct in_pktinfo *p;
+- } p;
+- p.c = CMSG_DATA(cmptr);
+- iface_index = p.p->ipi_ifindex;
+- if (p.p->ipi_addr.s_addr != INADDR_BROADCAST)
+- unicast_dest = 1;
+- }
++ {
++ for (cmptr = CMSG_FIRSTHDR(&msg); cmptr; cmptr = CMSG_NXTHDR(&msg, cmptr))
++ if (cmptr->cmsg_level == IPPROTO_IP && cmptr->cmsg_type == IP_PKTINFO)
++ {
++ union {
++ unsigned char *c;
++ struct in_pktinfo *p;
++ } p;
++ p.c = CMSG_DATA(cmptr);
++ iface_index = p.p->ipi_ifindex;
++ if (p.p->ipi_addr.s_addr != INADDR_BROADCAST)
++ unicast_dest = 1;
++ }
++ }
+
+ #elif defined(HAVE_BSD_NETWORK)
+ if (msg.msg_controllen >= sizeof(struct cmsghdr))
+--
+2.20.1
+
diff --git a/source/installer/sources/dnsmasq/dnsmasq.leasedir.diff b/source/installer/sources/dnsmasq/dnsmasq.leasedir.diff
new file mode 100644
index 000000000..9fec6b439
--- /dev/null
+++ b/source/installer/sources/dnsmasq/dnsmasq.leasedir.diff
@@ -0,0 +1,24 @@
+diff -Nur dnsmasq-2.52.orig/dnsmasq.conf.example dnsmasq-2.52/dnsmasq.conf.example
+--- dnsmasq-2.52.orig/dnsmasq.conf.example 2009-11-25 06:55:16.000000000 -0600
++++ dnsmasq-2.52/dnsmasq.conf.example 2010-01-22 15:32:41.137807274 -0600
+@@ -415,7 +415,7 @@
+ # The DHCP server needs somewhere on disk to keep its lease database.
+ # This defaults to a sane location, but if you want to change it, use
+ # the line below.
+-#dhcp-leasefile=/var/lib/misc/dnsmasq.leases
++#dhcp-leasefile=/var/state/dnsmasq/dnsmasq.leases
+
+ # Set the DHCP server to authoritative mode. In this mode it will barge in
+ # and take over the lease for any client which broadcasts on the network,
+diff -Nur dnsmasq-2.52.orig/src/config.h dnsmasq-2.52/src/config.h
+--- dnsmasq-2.52.orig/src/config.h 2010-01-21 08:22:06.000000000 -0600
++++ dnsmasq-2.52/src/config.h 2010-01-22 15:32:41.136833058 -0600
+@@ -47,7 +47,7 @@
+ # elif defined(__sun__) || defined (__sun)
+ # define LEASEFILE "/var/cache/dnsmasq.leases"
+ # else
+-# define LEASEFILE "/var/lib/misc/dnsmasq.leases"
++# define LEASEFILE "/var/state/dnsmasq/dnsmasq.leases"
+ # endif
+ #endif
+
diff --git a/source/installer/sources/dnsmasq/dnsmasq.libidn2.diff b/source/installer/sources/dnsmasq/dnsmasq.libidn2.diff
new file mode 100644
index 000000000..d99e556bc
--- /dev/null
+++ b/source/installer/sources/dnsmasq/dnsmasq.libidn2.diff
@@ -0,0 +1,13 @@
+--- ./Makefile.orig 2017-05-22 16:58:46.000000000 -0500
++++ ./Makefile 2017-07-07 13:28:14.124402827 -0500
+@@ -24,8 +24,8 @@
+ LOCALEDIR = $(PREFIX)/share/locale
+ BUILDDIR = $(SRC)
+ DESTDIR =
+-CFLAGS = -Wall -W -O2
+-LDFLAGS =
++CFLAGS = -Wall -W -O2 -DHAVE_LIBIDN2
++LDFLAGS = -lidn2
+ COPTS =
+ RPM_OPT_FLAGS =
+ LIBS =
diff --git a/source/installer/sources/initrd/etc/keymaps.tar b/source/installer/sources/initrd/etc/keymaps.tar
deleted file mode 100644
index 2ae6004b7..000000000
--- a/source/installer/sources/initrd/etc/keymaps.tar
+++ /dev/null
Binary files differ
diff --git a/source/installer/sources/initrd/etc/mounts b/source/installer/sources/initrd/etc/mtab
index 4c0a0948b..4c0a0948b 120000
--- a/source/installer/sources/initrd/etc/mounts
+++ b/source/installer/sources/initrd/etc/mtab
diff --git a/source/installer/sources/initrd/etc/rc.d/rc.S b/source/installer/sources/initrd/etc/rc.d/rc.S
index fcd5fea2c..0e69d7349 100755
--- a/source/installer/sources/initrd/etc/rc.d/rc.S
+++ b/source/installer/sources/initrd/etc/rc.d/rc.S
@@ -1,18 +1,29 @@
#!/bin/sh
# rc.S: Basic system initialization.
-# Any /etc/mtab that exists here is old, so we start with a new one:
-/bin/rm -f /etc/mtab{,~,.tmp} && /bin/touch /etc/mtab
-
-# Add (fake) entry for / to /etc/mtab:
-/sbin/mount -f -w /dev/initramfs / -t tmpfs 1> /dev/null
-
# Mount /proc:
/sbin/mount -v proc /proc -t proc 1> /dev/null
# Mount sysfs next:
/sbin/mount -v sysfs /sys -t sysfs 1> /dev/null
+# The efivarfs filesystem is used for reading and writing EFI variables, such
+# as the boot menu entries. By default efivarfs will be mounted read-write on
+# the /sys/firmware/efi/efivars directory.
+if [ -d /sys/firmware/efi/efivars ]; then
+ mount -o rw -t efivarfs none /sys/firmware/efi/efivars
+fi
+
+# Set a root password for the Slackware Installer if set as a Kernel cmdline:
+# This is intended for network installations where otherwise the root password
+# would be unset.
+# Note: this does not configure the OS root password.
+# Passwords should be set as follows within the Kernel cmdline:
+# instrootpw=yourpassword
+if grep -qoP 'instrootpw=\K\S+' /proc/cmdline ; then
+ /bin/echo "root:$( grep -oP 'instrootpw=\K\S+' /proc/cmdline )" | /bin/busybox chpasswd
+fi
+
# Activate swap:
/sbin/swapon -a 1> /dev/null
@@ -171,8 +182,14 @@ rm -f /tmp/foo
echo "Activating LVM volumes:"
vgchange -ay
-if [ -x /etc/rc.d/rc.font ]; then
- /bin/sh /etc/rc.d/rc.font
+# In testing here the results of running rc.font with HiDPI screens has been
+# rather unpredicable, sometimes resulting in an unreadably small font rather
+# than increasing the size. Let's skip it unless RCFONT is passed as a kernel
+# command-line flag:
+if cat /proc/cmdline | grep -wq RCFONT ; then
+ if [ -x /etc/rc.d/rc.font ]; then
+ /bin/sh /etc/rc.d/rc.font
+ fi
fi
# Don't automatically blank the screen, or it will go black during the install
@@ -233,11 +250,23 @@ if ! cat /proc/cmdline | grep -q 'kbd=' 2> /dev/null ; then
else
for ARG in `cat /proc/cmdline` ; do
if [ "`echo $ARG | cut -f1 -d=`" = "kbd" ]; then
- BMAP="`echo $ARG | cut -f2 -d=`.bmap"
+ # A keymap was specified on the kernel command line such as: kbd=azerty
+ MAPSELECT="$(echo $ARG | cut -f2 -d=)"
+ # If it ends in .gz, strip that off:
+ if [ "$(echo $MAPSELECT | rev | cut -f 1 -d . | rev)" = "gz" ]; then
+ MAPSELECT=$(basename $MAPSELECT .gz)
+ fi
+ # If it doesn't end in .map, add that:
+ if [ ! "$(echo $MAPSELECT | rev | cut -f 1 -d . | rev)" = "map" ]; then
+ MAPSELECT=${MAPSELECT}.map
+ fi
+ # Load the keymap:
+ loadkeys -q $MAPSELECT
+ # Let the setup script know about this:
+ echo $MAPSELECT > /tmp/Pkeymap
+ unset MAPSELECT
fi
done
- tar xzOf /etc/keymaps.tar.gz $BMAP | loadkmap
- unset BMAP
fi
clear
diff --git a/source/installer/sources/initrd/etc/rc.d/rc.pcmcia b/source/installer/sources/initrd/etc/rc.d/rc.pcmcia
index 1f21be84e..46621da97 100755
--- a/source/installer/sources/initrd/etc/rc.d/rc.pcmcia
+++ b/source/installer/sources/initrd/etc/rc.d/rc.pcmcia
@@ -14,7 +14,7 @@ DRIVER_OPTS=
case "$1" in
start)
echo "Starting PCMCIA services:"
- fgrep -q pcmcia /proc/devices
+ grep -F -q pcmcia /proc/devices
if [ $? -ne 0 ] ; then
if [ "$DRIVER" = "probe" ]; then
echo " <Probing for PCIC: edit /etc/rc.d/rc.pcmcia>"
diff --git a/source/installer/sources/initrd/sbin/mkbindmounts b/source/installer/sources/initrd/sbin/mkbindmounts
index 40a9d7313..897889847 100755
--- a/source/installer/sources/initrd/sbin/mkbindmounts
+++ b/source/installer/sources/initrd/sbin/mkbindmounts
@@ -5,6 +5,10 @@
# reinstall boot loaders).
mkdir -p /mnt/{dev,proc,sys}
-mount -o bind /dev /mnt/dev
-mount -o bind /proc /mnt/proc
-mount -o bind /sys /mnt/sys
+mount -o rbind /dev /mnt/dev
+mount -o rbind /proc /mnt/proc
+mount -o rbind /sys /mnt/sys
+# Needed for EFI boot menu operations:
+if [ -d /sys/firmware/efi/efivars ]; then
+ mount -o rbind /sys/firmware/efi/efivars /mnt/sys/firmware/efi/efivars
+fi
diff --git a/source/installer/sources/initrd/sbin/probe b/source/installer/sources/initrd/sbin/probe
index 3b481432f..a0c25ac10 100755
--- a/source/installer/sources/initrd/sbin/probe
+++ b/source/installer/sources/initrd/sbin/probe
@@ -140,24 +140,14 @@ list_amiraid() {
fi
}
-#list_mmc() {
-# # find drive
-# DRV=`expr $2 / 8`
-# NUM=`expr $2 % 8`
-# if [ "$NUM" = "0" ]; then
-# fdisk -l /dev/mmcblk$DRV >> $TMP/SeTfdisk
-# #output_gpt_partitions /dev/mmcblk$DRV >> $TMP/SeTfdisk
-# else
-# return
-# fi
-#}
list_mmc() {
local device
# Filter out any partitions on the block device, as we'll use
# fdisk to capture those:
- lsblk -o name,type -ripnd /dev/mmcblk* | egrep 'disk$' | awk '{print $1}' | while read device ; do
- fdisk -l $device >> $TMP/SeTfdisk
- done
+ grep -qE 'mmcblk[0-9]' /proc/partitions && {
+ lsblk -o name,type -Mripnd /dev/mmcblk* | grep -E 'disk$' | awk '{print $1}' | while read device ; do
+ fdisk -l $device >> $TMP/SeTfdisk
+ done ;}
}
list_nvme() {
@@ -324,6 +314,9 @@ list_lvm
# List CRYPT volumes:
list_crypt
+# List MMC (e.g. SD cards) partitions:
+list_mmc
+
## This is obsolete, since fdisk handles GPT now.
## List GPT partitions:
#cat /proc/partitions | while read line ; do
@@ -412,8 +405,6 @@ if cat /proc/partitions | grep -E '/|[0-9]' 1>/dev/null 2>/dev/null ; then # new
list_cciss $(( $MAJOR - 104 )) $MINOR
elif [ "$MAJOR" = "114" ]; then
list_ataraid $MAJOR $MINOR
- elif [ "$MAJOR" = "179" ]; then
- list_mmc $MAJOR $MINOR
elif [ "$MAJOR" = "259" ]; then
if echo $line | grep -q p; then
list_nvme $DEVNAME
@@ -443,4 +434,54 @@ sed -i -e "s/Linux filesystem/Linux/g" $TMP/SeTfdisk
sed -i -e "s/EFI System/EFI System Partition/g" $TMP/SeTfdisk
sed -i -e "s,EFI (FAT-12/16/32),EFI System Partition,g" $TMP/SeTfdisk
+# Filter out reserved file system labels for Slackware ARM/AArch64 and the
+# Slackware A-i-O (All in One Offline) Installer file systems.
+# This prevents them from being offered as candidates for formatting/mounting
+# during the installation.
+#
+# Labels:
+#
+# Used within the OS:
+# -------------------
+# SLKhwm_bw = Hardware Model Bootware - native Bootware for the RPi
+# SLKefi = FAT32 file system, /boot/efi mountpoint within the OS for Hardware Models
+# that use UEFI firmware.
+#
+# SLKins = Media (usually a USB stick) containing the Slackware install media
+# This FS label isn't required to locate the media, but it's helpful
+# as a way to exclude the media from the list of candidates.
+# This label is included within the Installation Guide for the USB
+# media installation option.
+#
+# Used only within the Slackware Installer environment
+# ----------------------------------------------------
+# SLKins_aio-pkgs =
+# The label of the partition on the All-In-One Installer that contains the
+# Slackware packages.
+# SLKins_efi = FAT32 file system for the Installer EFI partition, for Hardware Models
+# that use UEFI firmware.
+# The contents of this are deployed by 'grub-install', which is called from
+# the Hardware Model's 'sdcards.build' plugin.
+# This is not used within the installed OS.
+# SLKins_boot = ext4 file system containing the GRUB configuration to boot the
+# Slackware Installer, for Hardware Models using UEFI firmware.
+#
+# 'SLKroot' is used to identify the OS root file system on ARM, but we don't
+# filter it out because it's *supposed* to appear as a candidate within the
+# menu. Whilst we don't ship any images that contain a file system with this label,
+# the user might be reinstalling, thus would never be presented with the partition.
+#
+# SLKboot = Slackware OS /boot partition, but is only reserved only on ARM/AArch64:
+[[ "$( uname -m )" =~ a(rm*|arch64) ]] && aexc="boot|"
+
+awk '/^\/dev\// {print $1}' /var/log/setup/tmp/SeTfdisk | while read device; do
+ # The wrapping of e2label is because whilst it handles other file system types,
+ # it includes verbosity about the filesystem type; where as for ext filesystems
+ # it outputs only the label.
+ { ( e2label ${device} 2>/dev/null | tail -n1 | rev \
+ | awk '{print $1}' | rev | tr -d "'" | \
+ grep -Eq "^SLK(${aexc}ins|ins_aio-pkgs|ins_efi|ins_boot|efi|hwm_bw)$" ) && sed -i '\|^'"${device}\s"'|d' $TMP/SeTfdisk ;}
+done
+
+# Dump the discovered storage:
cat $TMP/SeTfdisk
diff --git a/source/installer/sources/initrd/usr/lib/setup/INS-all-in-one b/source/installer/sources/initrd/usr/lib/setup/INS-all-in-one
new file mode 100755
index 000000000..c6463626f
--- /dev/null
+++ b/source/installer/sources/initrd/usr/lib/setup/INS-all-in-one
@@ -0,0 +1,199 @@
+#!/bin/bash
+####################################################################################
+# File.......: /usr/lib/setup/INS-all-in-one
+# Called from: Forked from /usr/lib/setup/SeTmedia
+# Purpose....: Detect a partition labeled 'SLKins_aio-pkgs' and configure the
+# Installer to use it as the media source.
+# Version....: 1.00
+# Date.......: 22-Nov-2022
+# Author.....: Stuart Winter <mozes@slackware.com>
+###################################################################################
+# Change log
+# v1.00, 22-Nov-2022
+# * Initial version
+###################################################################################
+#
+# Copyright 2022 Stuart Winter, Earth, Milky Way, "".
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+# Exit codes
+# 0 = Success (Install media dialog screen can exit cleanly)
+# 1 = General failure. (Install media dialog needs to present the list of options)
+# 2 = No media label found on any removable block device.
+# 3 = Sanity checks failed.
+# 4 = User chose not to use the bundled media, although the media passed sanity check.
+# 10 = User configured not to use All-In-One feature.
+
+# Check if the user has bypassed the all-in-one Installer functionality.
+# This may be if they have the all-in-one Installer on the USB stick but want
+# to install from another medium, and don't fancy re-deploying the standard USB
+# Installer image to the USB stick.
+[ -f /.no-allinone ] && exit 10
+
+# Settings:
+SLKINSMNT=/slack-all-in-one
+TMP=/var/log/setup/tmp
+[ ! -d $TMP ] && mkdir -pm755 $TMP
+
+###################################################################################
+################### Functions #####################################################
+###################################################################################
+
+# This code was copied in part from usr/lib/setup/INSUSB:
+# Detect a device with a partition label 'SLKins_aio-pkgs'
+# The MMC block devices aren't identified as 'removeable' so we don't filter on
+# that attribute since this is the standard storage subsystem we use on ARM.
+#lsblk -o name,label -ripn | grep -E 'SLKins_aio-pkgs$'
+function media_scan(){
+ local rdevice founddev
+ for rdevice in $( ls --indicator-style none /sys/block | grep -Ev "loop|ram|^dm-|^sr|^md" ); do
+ # Is it labeled 'SLKins_aio-pkgs'? If so we'll take the first one we find:
+ founddev="$( lsblk -o name,label -ripn /dev/${rdevice} 2>/dev/null | grep -E 'SLKins_aio-pkgs$' | awk '{print $1}' )"
+ [ ! -z "${founddev}" ] && break
+ done
+ # Report back if we found one:
+ [ ! -z "${founddev}" ] && { echo "${founddev}" ; return 0 ;} || return 1
+}
+
+# Mount the specified block device under the known mount point:
+function media_mount() {
+ mount -o noatime -m "$1" $SLKINSMNT 2>/dev/null
+ return $? ;}
+
+# umount the media:
+function media_umount() {
+ umount $SLKINSMNT 2>/dev/null
+ return $? ;}
+
+# Check if the Slackware media partition is already mounted:
+function media_ismounted() {
+ findmnt -DRM ${SLKINSMNT} > /dev/null 2>&1
+ return $?
+}
+
+# Sanity check the media:
+# The directory layout is: '/slackware/<slackware-tree-name>'
+# This is to enable users to add non-Slackware related assets to the partition upon installation
+# of the OS, if they wish.
+function media_sanity_check() {
+ local slacktree=$( media_report_slacktree )
+ [ -z "$slacktree" ] && return 1
+ # Is the tree available? We'll check the 'A' series directory is present:
+ [ ! -d $SLKINSMNT/slackware/$slacktree/a ] && return 1
+ # Enough sanity checking, it's probably good!
+ return 0
+}
+
+# Report the path to the configured Slackware media:
+# Output is relative - e.g. doesn's include the mount point and parent 'slackware' directory.
+function media_report_slacktree() {
+ # The Slackware tree we're using is configured in this file.
+ # This is placed by the script that creates the All-in-One Installer image.
+ [ ! -f $SLKINSMNT/slackware/.slktree ] && return 1
+ # Output content of the file which is a relative path: e.g. "slackwareaarch64-current/slackware"
+ grep -Ev '^$' $SLKINSMNT/slackware/.slktree
+}
+
+# Inform the user that the All-in-One Installer is ready to go.
+function offer_msg_ready() {
+ local blockdev="$1" mntpnt="$2"
+# --msgbox "\nThe Slackware package directory has been found on $blockdev and is mounted on $mntpnt ready for use.\n
+ dialog \
+ --backtitle "Slackware Installer" \
+ --title "INSTALLATION MEDIA SOURCE FOUND" --ok-button "OK" \
+ --msgbox "\nThis edition of the Slackware Installer has the installation media bundled, and is ready to use.\n
+ " 8 79
+ clear
+}
+
+# Inform the user that the All-in-One Installer was detected but failed sanity check.
+function offer_msg_failsanity() {
+ local blockdev="$1" mntpnt="$2"
+ dialog \
+ --backtitle "Slackware Installer" \
+ --title "INSTALLATION MEDIA SOURCE" --ok-button "OK" \
+ --msgbox "\nThis edition of the Slackware Installer contains the installation media.\n\n
+The media has been located on $blockdev but has failed the tests.\n\n
+You will now be presented with the option to choose a different installation media source.\n" 12 79
+ clear
+}
+
+# Offer the option to use the bundled media or pick the option manually:
+# Y=return 0, N=1
+function offer_chooseaio() {
+ dialog \
+ --backtitle "Slackware Installer" \
+ --title "INSTALLATION MEDIA SOURCE" --yesno \
+ "\nThis edition of the Slackware Installer contains the installation media.\n\n
+Would you like to use this as the media source?\n\n
+Answering 'No' provides a list of alternate installation media selection options.\n\n
+Recommendation: Yes" 15 77
+ return $?
+}
+
+# Configure the Slackware Installer to find the installation media on the All-in-One partition:
+function installer_configure() {
+ # An example of the entry in this file: /slack-all-in-one/slackware/slackwareaarch64-current/slackware
+ echo "$SLKINSMNT/slackware/$( media_report_slacktree )" > $TMP/SeTDS # is $SLKINSMNT/slackware/[contents of file '.slktree']
+ echo "-source_mounted" > $TMP/SeTmount
+ echo "/dev/null" > $TMP/SeTsource
+}
+
+###################################################################################
+
+# Try to locate the All-in-One Installer partition:
+mediablockdev=$( media_scan )
+
+# If we didn't find a block device with our label, bail out to enable the user to select
+# one from the list presented by /usr/lib/setup/SeTmedia:
+[ -z "${mediablockdev}" ] && exit 2
+
+# If the media is already mounted and the sanity check passes, inform the user.
+# This is to facilitate that the user may bounce through the main 'setup' menu and select
+# the installation media chooser (/usr/lib/setup/SeTmedia) more than once.
+# No, we're not going to offer them the option to pick a different installation source media:
+# it might break something. They can reboot.
+if media_ismounted && media_sanity_check; then
+ offer_msg_ready $mediablockdev $SLKINSMNT
+ exit 0
+fi
+
+# It's not mounted, but we found a label on a removable block device. Let's mount it,
+# configure the Installer to find the package source media, and inform the user that it's
+# ready to roll:
+if media_mount $mediablockdev && media_sanity_check; then
+ # Give the user the choice to use it. At this point we know it's validated so is a viable option.
+ # If the user chooses 'no', we umount the media and are returned to the '/usr/lib/setup/SeTmedia'
+ # process to pick an option.
+ offer_chooseaio || { media_umount ; clear ; exit 4 ;}
+ installer_configure
+ #offer_msg_ready $mediablockdev $SLKINSMNT
+ exit 0
+ else
+ # umount the media. If it fails, no problem - we can ignore it. The Installer won't be configured
+ # to use it unless the sanity check passed, so anything mounted isn't used nor is in the way.
+ media_umount
+ # Inform the user that they get to pick from the list of source media installation options:
+ offer_msg_failsanity $mediablockdev
+ exit 3
+fi
+
+clear
+exit 0
diff --git a/source/installer/sources/initrd/usr/lib/setup/SeTEFI b/source/installer/sources/initrd/usr/lib/setup/SeTEFI
index fdf545849..2e1f38eef 100755
--- a/source/installer/sources/initrd/usr/lib/setup/SeTEFI
+++ b/source/installer/sources/initrd/usr/lib/setup/SeTEFI
@@ -1,4 +1,8 @@
#!/bin/sh
+
+# Script: /usr/lib/setup/SeTEFI
+# Called from: /usr/lib/setup/setup
+
TMP=/var/log/setup/tmp
T_PX="`cat $TMP/SeTT_PX`"
if [ ! -d $TMP ]; then
@@ -16,14 +20,21 @@ rm -f $TMP/SeTefipartitions
touch $TMP/SeTefipartitions
# Scan for EFI partitions:
-# The UEFI specification states that an EFI System partition should have
+# The UEFI specification states that an EFI System partition should have
# a GUID of C12A7328-F81F-11D2-BA4B-00A0C93EC93B for a GPT disk layout.
# In case of a MBR disk layout instead, an ESP should have an OS type of
# 0xEF. lsblk writes these values in the same field: PARTTYPE.
+#
+# AArch64 note: Any file systems labeled 'SLKins_efi' are filtered out
+# because on the AArch64 platform, the Slackware Installer image has its
+# own EFI boot partition to support Hardware Models using UEFI firmware.
+# This partition must be filtered out here to avoid it being incorrectly
+# selected as the OS's EFI partition.
ESPGUID=C12A7328-F81F-11D2-BA4B-00A0C93EC93B
OSTYPE=0xEF
-lsblk -l -o parttype,name | \
-grep -i -F -e "$ESPGUID" -e "$OSTYPE" | \
+lsblk -Ml -o parttype,name,label | \
+grep -v 'SLKins_efi$' | \
+grep -iFe "$ESPGUID" -e "$OSTYPE" | \
sed "s,[^ ]*[ ]*,/dev/," > $TMP/SeTefipartitions
if [ ! -s $TMP/SeTefipartitions ]; then # No EFI partitions
diff --git a/source/installer/sources/initrd/usr/lib/setup/SeTconfig b/source/installer/sources/initrd/usr/lib/setup/SeTconfig
index 6731019bb..b51e991dc 100755
--- a/source/installer/sources/initrd/usr/lib/setup/SeTconfig
+++ b/source/installer/sources/initrd/usr/lib/setup/SeTconfig
@@ -43,6 +43,10 @@ if [ ! "$T_PX" = "/" ]; then
mount --bind /proc $T_PX/proc 1> /dev/null 2> /dev/null
mount --bind /sys $T_PX/sys 1> /dev/null 2> /dev/null
mount --bind /dev $T_PX/dev 1> /dev/null 2> /dev/null
+ # Needed for EFI boot menu operations:
+ if [ -d /sys/firmware/efi/efivars ]; then
+ mount --bind /sys/firmware/efi/efivars $T_PX/sys/firmware/efi/efivars 1> /dev/null 2> /dev/null
+ fi
fi
# These will be left connected rather than unmounting them to
# make it easier to set up LVM/LUKS.
diff --git a/source/installer/sources/initrd/usr/lib/setup/SeTkeymap b/source/installer/sources/initrd/usr/lib/setup/SeTkeymap
index e8ac96396..ce1e6d778 100755
--- a/source/installer/sources/initrd/usr/lib/setup/SeTkeymap
+++ b/source/installer/sources/initrd/usr/lib/setup/SeTkeymap
@@ -1,6 +1,6 @@
#!/bin/sh
# Copyright 1993, 1999, 2002 Patrick Volkerding, Moorhead, MN.
-# Copyright 2009 Patrick J. Volkerding, Sebeka, MN, USA
+# Copyright 2009, 2023 Patrick J. Volkerding, Sebeka, MN, USA
# Use and redistribution covered by the same terms as the "setup" script.
TMP=/var/log/setup/tmp
RDIR=/dev/tty4
@@ -8,183 +8,30 @@ if [ ! -d $TMP ]; then
mkdir -p $TMP
fi
while [ 0 ]; do
+
+# Construct the list of available keymaps:
+MAPLIST="$(cd /usr/share/kbd/keymaps/i386 ; find azerty bepo carpalx colemak dvorak fgGIod neo olpc qwerty qwertz | grep / | grep .map.gz$ | rev | cut -f 2- -d . | rev | less | sort | less | sed "s|^|\"|g" | sed "s|$|\" \"\" |g" | tr -d "\n")"
+
+cat << EOF > $TMP/select_keymap.sh
dialog --title "KEYBOARD MAP SELECTION" --menu "You may select one \
of the following keyboard maps. If you do not select a keyboard \
map, 'us.map' (the US keyboard map) is the default. Use the UP/DOWN \
arrow keys and PageUp/PageDown to scroll \
through the whole list of choices." \
22 55 11 \
-"qwerty/us.map" "" \
-"qwerty/uk.map" "" \
-"azerty/azerty.map" "" \
-"azerty/be-latin1.map" "" \
-"azerty/fr-latin0.map" "" \
-"azerty/fr-latin1.map" "" \
-"azerty/fr-latin9.map" "" \
-"azerty/fr-old.map" "" \
-"azerty/fr-pc.map" "" \
-"azerty/fr.map" "" \
-"azerty/wangbe.map" "" \
-"azerty/wangbe2.map" "" \
-"colemak/en-latin9.map" "" \
-"dvorak/ANSI-dvorak.map" "" \
-"dvorak/dvorak-fr.map" "" \
-"dvorak/dvorak-l.map" "" \
-"dvorak/dvorak-r.map" "" \
-"dvorak/dvorak.map" "" \
-"dvorak/no-dvorak.map" "" \
-"fgGIod/tr_f-latin5.map" "" \
-"fgGIod/trf-fgGIod.map" "" \
-"olpc/es-olpc.map" "" \
-"olpc/pt-olpc.map" "" \
-"qwerty/bashkir.map" "" \
-"qwerty/bg-cp1251.map" "" \
-"qwerty/bg-cp855.map" "" \
-"qwerty/bg_bds-cp1251.map" "" \
-"qwerty/bg_bds-utf8.map" "" \
-"qwerty/bg_pho-cp1251.map" "" \
-"qwerty/bg_pho-utf8.map" "" \
-"qwerty/br-abnt.map" "" \
-"qwerty/br-abnt2.map" "" \
-"qwerty/br-latin1-abnt2.map" "" \
-"qwerty/br-latin1-us.map" "" \
-"qwerty/by-cp1251.map" "" \
-"qwerty/by.map" "" \
-"qwerty/bywin-cp1251.map" "" \
-"qwerty/cf.map" "" \
-"qwerty/cz-cp1250.map" "" \
-"qwerty/cz-lat2-prog.map" "" \
-"qwerty/cz-lat2.map" "" \
-"qwerty/cz-qwerty.map" "" \
-"qwerty/defkeymap.map" "" \
-"qwerty/defkeymap_V1.0.map" "" \
-"qwerty/dk-latin1.map" "" \
-"qwerty/dk.map" "" \
-"qwerty/emacs.map" "" \
-"qwerty/emacs2.map" "" \
-"qwerty/es-cp850.map" "" \
-"qwerty/es.map" "" \
-"qwerty/et-nodeadkeys.map" "" \
-"qwerty/et.map" "" \
-"qwerty/fi-latin1.map" "" \
-"qwerty/fi-latin9.map" "" \
-"qwerty/fi-old.map" "" \
-"qwerty/fi.map" "" \
-"qwerty/gr-pc.map" "" \
-"qwerty/gr.map" "" \
-"qwerty/hu101.map" "" \
-"qwerty/il-heb.map" "" \
-"qwerty/il-phonetic.map" "" \
-"qwerty/il.map" "" \
-"qwerty/is-latin1-us.map" "" \
-"qwerty/is-latin1.map" "" \
-"qwerty/it-ibm.map" "" \
-"qwerty/it.map" "" \
-"qwerty/it2.map" "" \
-"qwerty/jp106.map" "" \
-"qwerty/kazakh.map" "" \
-"qwerty/ky_alt_sh-UTF-8.map" "" \
-"qwerty/kyrgyz.map" "" \
-"qwerty/la-latin1.map" "" \
-"qwerty/lt.baltic.map" "" \
-"qwerty/lt.l4.map" "" \
-"qwerty/lt.map" "" \
-"qwerty/mk-cp1251.map" "" \
-"qwerty/mk-utf.map" "" \
-"qwerty/mk.map" "" \
-"qwerty/mk0.map" "" \
-"qwerty/nl.map" "" \
-"qwerty/nl2.map" "" \
-"qwerty/no-latin1.map" "" \
-"qwerty/no.map" "" \
-"qwerty/pc110.map" "" \
-"qwerty/pl.map" "" \
-"qwerty/pl1.map" "" \
-"qwerty/pl2.map" "" \
-"qwerty/pl3.map" "" \
-"qwerty/pl4.map" "" \
-"qwerty/pt-latin1.map" "" \
-"qwerty/pt-latin9.map" "" \
-"qwerty/pt.map" "" \
-"qwerty/ro.map" "" \
-"qwerty/ro_std.map" "" \
-"qwerty/ru-cp1251.map" "" \
-"qwerty/ru-ms.map" "" \
-"qwerty/ru-yawerty.map" "" \
-"qwerty/ru.map" "" \
-"qwerty/ru1.map" "" \
-"qwerty/ru2.map" "" \
-"qwerty/ru3.map" "" \
-"qwerty/ru4.map" "" \
-"qwerty/ru_win.map" "" \
-"qwerty/ruwin_alt-CP1251.map" "" \
-"qwerty/ruwin_alt-KOI8-R.map" "" \
-"qwerty/ruwin_alt-UTF-8.map" "" \
-"qwerty/ruwin_cplk-CP1251.map" "" \
-"qwerty/ruwin_cplk-KOI8-R.map" "" \
-"qwerty/ruwin_cplk-UTF-8.map" "" \
-"qwerty/ruwin_ct_sh-CP1251.map" "" \
-"qwerty/ruwin_ct_sh-KOI8-R.map" "" \
-"qwerty/ruwin_ct_sh-UTF-8.map" "" \
-"qwerty/ruwin_ctrl-CP1251.map" "" \
-"qwerty/ruwin_ctrl-KOI8-R.map" "" \
-"qwerty/ruwin_ctrl-UTF-8.map" "" \
-"qwerty/se-fi-ir209.map" "" \
-"qwerty/se-fi-lat6.map" "" \
-"qwerty/se-ir209.map" "" \
-"qwerty/se-lat6.map" "" \
-"qwerty/se-latin1.map" "" \
-"qwerty/sk-prog-qwerty.map" "" \
-"qwerty/sk-qwerty.map" "" \
-"qwerty/speakup-jfw.map" "" \
-"qwerty/speakupmap.map" "" \
-"qwerty/sr-cy.map" "" \
-"qwerty/sv-latin1.map" "" \
-"qwerty/tj_alt-UTF8.map" "" \
-"qwerty/tr_q-latin5.map" "" \
-"qwerty/tralt.map" "" \
-"qwerty/trf.map" "" \
-"qwerty/trq.map" "" \
-"qwerty/ttwin_alt-UTF-8.map" "" \
-"qwerty/ttwin_cplk-UTF-8.map" "" \
-"qwerty/ttwin_ct_sh-UTF-8.map" "" \
-"qwerty/ttwin_ctrl-UTF-8.map" "" \
-"qwerty/ua-cp1251.map" "" \
-"qwerty/ua-utf-ws.map" "" \
-"qwerty/ua-utf.map" "" \
-"qwerty/ua-ws.map" "" \
-"qwerty/ua.map" "" \
-"qwerty/uk.map" "" \
-"qwerty/us-acentos.map" "" \
-"qwerty/us.map" "" \
-"qwertz/croat.map" "" \
-"qwertz/cz-us-qwertz.map" "" \
-"qwertz/cz.map" "" \
-"qwertz/de-latin1-nodeadkeys.map" "" \
-"qwertz/de-latin1.map" "" \
-"qwertz/de-mobii.map" "" \
-"qwertz/de.map" "" \
-"qwertz/de_CH-latin1.map" "" \
-"qwertz/de_alt_UTF-8.map" "" \
-"qwertz/fr_CH-latin1.map" "" \
-"qwertz/fr_CH.map" "" \
-"qwertz/hu.map" "" \
-"qwertz/sg-latin1-lk450.map" "" \
-"qwertz/sg-latin1.map" "" \
-"qwertz/sg.map" "" \
-"qwertz/sk-prog-qwertz.map" "" \
-"qwertz/sk-qwertz.map" "" \
-"qwertz/slovene.map" "" \
+"qwerty/us.map" "" "qwerty/uk.map" "" $MAPLIST \
2> $TMP/SeTkeymap
+EOF
+ sh $TMP/select_keymap.sh
if [ ! $? = 0 ]; then
- rm -f $TMP/SeTkeymap
+ rm -f $TMP/SeTkeymap $TMP/select_keymap.sh
exit
fi
- MAPNAME="`cat $TMP/SeTkeymap`"
- MAPNAME="`basename $MAPNAME`"
+ rm -f $TMP/select_keymap.sh
+ MAPNAME="$(cat $TMP/SeTkeymap)"
+ MAPNAME="$(basename $MAPNAME)"
echo $MAPNAME > $TMP/SeTkeymap
- BMAP="`basename $MAPNAME .map`.bmap"
- tar xzOf /etc/keymaps.tar.gz $BMAP > /dev/null && tar xzOf /etc/keymaps.tar.gz $BMAP | loadkmap
+ loadkeys -q $MAPNAME
while [ 0 ]; do
# Match the dialog colors a little while doing the keyboard test:
@@ -214,7 +61,7 @@ EOF
rm -f $TMP/$MAPNAME
rm -f $TMP/SeTkeymap $TMP/Pkeymap
# Clear bad selection:
- tar xzOf /etc/keymaps.tar.gz us.bmap > /dev/null && tar xzOf /etc/keymaps.tar.gz us.bmap | loadkmap
+ loadkeys -q us.map
continue;
fi
done
diff --git a/source/installer/sources/initrd/usr/lib/setup/SeTmedia b/source/installer/sources/initrd/usr/lib/setup/SeTmedia
index 65e05f4db..d42658c99 100755
--- a/source/installer/sources/initrd/usr/lib/setup/SeTmedia
+++ b/source/installer/sources/initrd/usr/lib/setup/SeTmedia
@@ -1,9 +1,19 @@
-#!/bin/sh
+#!/bin/bash
TMP=/var/log/setup/tmp
if [ ! -d $TMP ]; then
mkdir -p $TMP
fi
+# Call the A-i-O (All-in-One Offline Installer) media handler.
+# This is for Slackware Installer images that contain a partition
+# labeled 'SLKins_aio' which holds the Slackware packages.
+# If a partition exists, passes the sanity checks and the user
+# wants to use the bundled media, we exit.
+# Otherwise, if the user creates a file named '/.no-allinone', the
+# the sanity checks fail or the user doesn't want to use the
+# media, we offer the set of options to select the source media.
+INS-all-in-one && exit 0
+
dialog --backtitle "Select Slackware installation source." \
--title "SOURCE MEDIA SELECTION" --menu \
"Please select the media from which to install Slackware Linux:" \
diff --git a/source/installer/sources/initrd/usr/lib/setup/SeTpasswd b/source/installer/sources/initrd/usr/lib/setup/SeTpasswd
index 967ffd2ed..16133c423 100755
--- a/source/installer/sources/initrd/usr/lib/setup/SeTpasswd
+++ b/source/installer/sources/initrd/usr/lib/setup/SeTpasswd
@@ -13,9 +13,11 @@ time the machine is rebooted. This is especially important if you're \
using a network enabled kernel and the machine is on an Internet \
connected LAN. Would you like to set a root password?" 10 68
if [ $? = 0 ] ; then
+ clear
echo
echo
echo
+ echo "Setting password for 'root' user"
chroot $T_PX /usr/bin/passwd root
echo
echo -n "Press [enter] to continue:"
diff --git a/source/installer/sources/initrd/usr/lib/setup/pxesetup b/source/installer/sources/initrd/usr/lib/setup/pxesetup
index fb7831a39..7241b5c8c 100755
--- a/source/installer/sources/initrd/usr/lib/setup/pxesetup
+++ b/source/installer/sources/initrd/usr/lib/setup/pxesetup
@@ -40,12 +40,12 @@ export COLOR=on
# before the boot - perhaps the Slackware tree is on a local partition:
vgchange -ay 1> /dev/null 2> /dev/null
if probe -l 2> /dev/null | grep -E 'Linux$' 1> /dev/null 2> /dev/null ; then
- probe -l 2> /dev/null | grep -E 'Linux$' | sort 1> $TMP/SeTplist 2> /dev/null
+ probe -l 2> /dev/null | grep -E 'Linux$' | sort | uniq 1> $TMP/SeTplist 2> /dev/null
fi
while [ 0 ]; do
- dialog --title "Slackware PXE Setup (version 13.37)" \
+ dialog --title "Slackware PXE Setup (version 15.1)" \
--menu \
"Welcome to Slackware PXE Setup.\n\
Select an option below using the UP/DOWN keys and SPACE or ENTER.\n\
diff --git a/source/installer/sources/initrd/usr/lib/setup/setup b/source/installer/sources/initrd/usr/lib/setup/setup
index 5fc8a0e4b..6eb96dc3a 100755
--- a/source/installer/sources/initrd/usr/lib/setup/setup
+++ b/source/installer/sources/initrd/usr/lib/setup/setup
@@ -1,25 +1,25 @@
-#!/bin/sh
+#!/bin/bash
#
# Copyright 1993, 1994, 1999 Patrick Volkerding, Moorhead, Minnesota USA
# Copyright 2001, 2003, 2004 Slackware Linux, Inc., Concord, CA
-# Copyright 2006, 2007, 2018, 2021, 2022 Patrick Volkerding, Sebeka, Minnesota USA
+# Copyright 2006, 2007, 2018, 2021, 2022, 2023 Patrick Volkerding, Sebeka, Minnesota USA
# All rights reserved.
#
-# Redistribution and use of this script, with or without modification, is
+# Redistribution and use of this script, with or without modification, is
# permitted provided that the following conditions are met:
#
# 1. Redistributions of this script must retain the above copyright
# notice, this list of conditions and the following disclaimer.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
-# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
-# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
-# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
-# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
-# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
# As always, bug reports, suggestions, etc: volkerdi@slackware.com
@@ -61,6 +61,10 @@ To do this, you'll need to leave 'setup', and make the partitions using \
information, read the 'setup' help file from the next menu." 10 64
fi
if [ -d /sys/firmware/efi ]; then
+ # First, let's make sure that efivarfs is active:
+ if [ "$(/bin/ls /sys/firmware/efi/efivars 2> /dev/null | wc -l)" = "0" ]; then
+ mount -t efivarfs none /sys/firmware/efi/efivars
+ fi
if ! probe -l 2> /dev/null | grep "EFI System Partition" 1> /dev/null 2> /dev/null ; then
dialog --title "NO EFI SYSTEM PARTITION DETECTED" \
--msgbox "This machine appears to be using EFI/UEFI, but no EFI System \
@@ -76,11 +80,11 @@ ROOT_DEVICE="`mount | grep "on / " | cut -f 1 -d ' '`"
echo "$ROOT_DEVICE" > $TMP/SeTrootdev
if mount | grep /var/log/mount 1> /dev/null 2> /dev/null ; then # clear source location:
# In case of bind mounts, try to unmount them first:
- umount /var/log/mount/dev 2> /dev/null
- umount /var/log/mount/proc 2> /dev/null
- umount /var/log/mount/sys 2> /dev/null
+ umount -R /var/log/mount/dev 2> /dev/null
+ umount -R /var/log/mount/proc 2> /dev/null
+ umount -R /var/log/mount/sys 2> /dev/null
# Unmount target partition:
- umount /var/log/mount
+ umount -R /var/log/mount
fi
# Anything mounted on /var/log/mount now is a fatal error:
if mount | grep /var/log/mount 1> /dev/null 2> /dev/null ; then
@@ -100,7 +104,7 @@ mkdir /var/log/mount 2> /dev/null
while [ 0 ]; do
- dialog --title "Slackware Linux Setup (version 15.0)" \
+ dialog --title "Slackware Linux Setup (version 15.1)" \
--menu \
"Welcome to Slackware Linux Setup.\n\
Select an option below using the UP/DOWN keys and SPACE or ENTER.\n\
@@ -336,9 +340,9 @@ to choose packages individually." 4 60
if [ "$MAINSELECT" = "CONFIGURE" ]; then
# Make bind mounts for /dev, /proc, and /sys:
- mount -o bind /dev $T_PX/dev 2> /dev/null
- mount -o bind /proc $T_PX/proc 2> /dev/null
- mount -o bind /sys $T_PX/sys 2> /dev/null
+ mount -o rbind /dev $T_PX/dev 2> /dev/null
+ mount -o rbind /proc $T_PX/proc 2> /dev/null
+ mount -o rbind /sys $T_PX/sys 2> /dev/null
SeTconfig
REPLACE_FSTAB=Y
if [ -r $TMP/SeTnative ]; then
@@ -388,7 +392,7 @@ if mount | grep /var/log/mntiso 1> /dev/null 2> /dev/null ; then
umount -f /var/log/mntiso
fi
if mount | grep /var/log/mount 1> /dev/null 2> /dev/null ; then
- umount /var/log/mount
+ umount -R /var/log/mount
fi
# Anything mounted on /var/log/mount now is a fatal error:
if mount | grep /var/log/mount 1> /dev/null 2> /dev/null ; then
@@ -436,6 +440,24 @@ if [ -f ${T_PX}/etc/fstab ]; then
"\nYou may now physically unplug the Slackware Installation Media USB stick from the USB port.\n" 8 60
}
+ # Prompt the user to unplug the bootable USB stick containing
+ # A-i-O (All in One Offline) partition.
+ mountpoint -q /slack-all-in-one && {
+ # Try to umount the A-i-O partition, but ignore any errors (errors would typically be
+ # occur if the user has a shell open within the USB stick's mount point), since
+ # we'll be shutting down soon anyway.
+ sync
+ umount /slack-all-in-one > /dev/null 2>&1
+ # Don't suggest disconnection if it's on ARM, because the A-i-O partition
+ # is on the same SD card that is converted from being the Installer to the
+ # OS's /boot partition.
+ [[ ! "$( uname -m )" =~ a(rm*|arch64) ]] && {
+ dialog \
+ --title "Unplug Slackware Installation USB Stick" \
+ --msgbox \
+ "\nYou may now physically unplug the Slackware Installation USB stick from the USB port.\n" 8 60 ;}
+ }
+
# Offer to reboot or drop to shell or power off.
exec 3>&1
installerexittype=$( dialog \